#ifndef _CONF_PARSER_H_
#define _CONF_PARSER_H_

/*
 * This is the structure defining a token. A token is either a word or
 * a string surrounded by double quotes.
 */
struct token {
	TAILQ_ENTRY(token) next;
	const char *str;
	unsigned offset; /* offset in line */
};

/* A line is a list of token, plus a flag indicating if the line
 * starts with space/tab */
TAILQ_HEAD(token_list, token);
struct line {
	int start_with_space;
	struct token_list token_list;
	unsigned n_token;
};

struct confnode;

int confnode_check_deps(const struct confnode *n, int verbose);
struct confnode *conf_reset_and_read(struct confnode *prev,
				     const char *dotconfig_filename);

int parse_conf_file(const char *filename, struct confnode **pparent,
		    struct confnode **pcurrent);
int confnode_get_value(const struct confnode *n, char *buf, unsigned buflen);

#endif /* _CONF_PARSER_H_ */
