#ifndef _EXPRESSION_H_
#define _EXPRESSION_H_

enum op_type {
	OP_VAR,
	OP_OBRACKET,
	OP_CBRACKET,
	OP_OR,
	OP_AND,
	OP_NOT,
	OP_EQUAL,
	OP_EOF,
};

struct expr_op {
	enum op_type optype;
	char *name; /* only valid if op==VAR */
};

struct expr_node {
	TAILQ_ENTRY(expr_node) next;
	struct expr_op op;
	struct expr_node *left;
	struct expr_node *right;
};

struct expr_node *parse_expression(char *buf);

void expression_free(struct expr_node *expression);
int expression_to_str(struct expr_node *n, char *buf, int len);
int expression_eval(struct expr_node *node);

#endif /* _EXPRESSION_H_ */
