/*
 * Copyright (c) 2009, Olivier MATZ <zer0@droids-corp.org>
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the University of California, Berkeley nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE REGENTS AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _PARSE_CONF_NODE_H_
#define _PARSE_CONF_NODE_H_

/* data is a 'node **' */
struct token_conf_node_data {
	struct confnode **root;
	struct confnode **cur;
	int flags;
	int mask;
};

struct token_conf_node {
	struct cmdline_token_hdr hdr;
	struct token_conf_node_data conf_node_data;
};
typedef struct token_conf_node parse_token_conf_node_t;

extern struct cmdline_token_ops token_conf_node_ops;

#define TOKEN_CONF_NODE_INITIALIZER(structure, field,		    \
				    root_node_ptr, cur_node_ptr,    \
				    node_flags, node_mask)	    \
{								    \
	.hdr = {						    \
		.ops = &token_conf_node_ops,			    \
		.offset = offsetof(structure, field),		    \
	},							    \
		.conf_node_data = {				    \
		.root = root_node_ptr,				    \
		.cur = cur_node_ptr,				    \
		.flags = node_flags,				    \
		.mask = node_mask,				    \
	},							    \
}

#endif /* _PARSE_CONF_NODE_H_ */
